#
# AnkaBT modules.
#
# Copyright (c) 2002, Anka Bilgi Teknolojileri
#
# See the README file for information on usage and redistribution.
#
__version__ = "1.0"


from Products.PythonScripts.Utility import allow_module, allow_class
from AccessControl import ModuleSecurityInfo, ClassSecurityInfo
from Globals import InitializeClass
from Products.CMFCore.DirectoryView import registerDirectory

kuzgun_globals = globals()

# Make the skins available as DirectoryViews
registerDirectory('skins', kuzgun_globals)
registerDirectory('skins/kuzgun_dbschedular', kuzgun_globals)
registerDirectory('skins/kuzgun_scripts/JavaScripts', kuzgun_globals)


# Make the classes available to Python Scripts
allow_module('kzXMLSentence')
from kzXMLSentence import *
allow_class(kzXMLSentence)


allow_module('kzSort')
import kzSort
allow_class(kzSort)


allow_module('kzDate')
from kzDate.kzDate import kzDate
allow_class(kzDate)

allow_module('kzMoney')
from kzMoney.kzMoney import kzMoney
allow_class(kzMoney)

allow_module('kzNumeric')
from kzNumeric.kzNumeric import kzNumeric
allow_class(kzNumeric)

allow_module('kzStatistic')
from kzStatistics.kzMatrix import matrix
allow_class(matrix)
from kzStatistics import kzStatistics
allow_class(kzStatistics)
from kzStatistics import kzVariableSelection
allow_class(kzVariableSelection)
from kzStatistics import kzRegression
allow_class(kzRegression)

allow_module('kzString')
from kzString.kzString import kzString
allow_class(kzString)
