# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
'''
def frekans(x) #x in olasl

def guven aral
anlam dzeyi
alfa,z-tablosu 
standard sapma: oran(kategorik), ortalama ,
z-t  testi :tek populasyon ve ift populasyon iin 
kategorik ve srekli deikenler iin 

t - test  :
    2 populasyon, veriler srekli deiken

    
ki-kare :(tek populasyon) iki kategorik deiken 
variancelara bal olarak 

F - test  :iki populasyonun variancelarnn karlatrlmas
birer tane srekli deiken

z-t transformasyon testi:tek veya ift populasyon olabilir ,korelasyonu inceler
2 tane srekli deiken

One Way ANOVA (variancelarn analizi):bir baml(srekli) bir bamsz(kategorisi 2 den fazla olacak) deiken 
Two Way ANOVA : bir baml 2 bamsz deiken

'''



import sys
def mean(X_list): #populasyonun ortalamas
    if(type(X_list) != type([])):
        raise 'mean:parametre liste olmal'
    x_mean = 0
    for i in range(len(X_list)):
	try:
            x_mean = x_mean + int( X_list[i] )
	except:pass
    #forend
    if len(X_list):
        return x_mean / float(len(X_list))
    return 0

def mod(X_list): # en ok tekrarlayan
    if(type(X_list) != type([])):
        raise 'mod:parametre liste olmal'
    x_mod  = 0
    repeat = 0
    count  = 0
    X_list.sort()
    for i in range(len(X_list)):
        if( X_list[i] == X_list[i-1] ):
            count = count + 1
        else :
            if( count > repeat ):
                x_mod  = X_list[i-1]
                repeat = count
            count = 1
    return x_mod
        
def medyan(X_list): # ortanca
    if(type(X_list) != type([])):
        raise 'medyan:parametre liste olmal'
    X_list.sort()
    length = len(X_list)
    if( length % 2 == 0):
        return ( X_list[(length/2)-1] + X_list[(length/2)]) / 2.0
    else :
        return X_list[ (length-1)/2 ]
    
def frekans(X_list,xi):
    return X_list.count(xi)
    
def standardDeviation(X_list):
    try:
        v = variance(X_list)
    except:
        raise sys.exc_type + '|standardDeviation:'
    s    = pow(v , 0.5 )
    return s 

def variance(X_list):
    try:
        Xort = mean(X_list)        
    except:
        raise sys.exc_type + '|variance:'
    
    s = 0 # standardDeviation(X_list)
    for Xi in X_list:
        s = s + pow((Xi - Xort),2.0) 
      
    variance = s / float(len(X_list) -1)
    
    return variance
    
def proportion(X_list,xi):
    try:
        f = frekans(xi)
        p = f / len(X_list)
        return p
    except:
        raise sys.exc_type + '|proportion:'
    
    
    
    
def standardErrorprop1(XList,x1):
    p = proportion(XList,x1)
    return pow((p * (1-p))/ len(XList),0.5)








def standardErrorprop2(X1List,x1,X2List,x2):
    p1 = proportion(X1List,x1)
    p2 = proportion(X2List,x2)
    return     pow( (p1 * (1-p1))/len(X1List)  + (p2 * (1- p2))/ len(X2List) , 0.5)
    
    
    
    
    
    
    
    
def confidenceIntprop1(X1List,x1,alfa): # return int1,int2
    p = proportion(X1List,x1)
    sigma = standardErrorprop1(X1List,x1)
    z   = zTable(alfa/2)
    return p - z * sigma , p + z * sigma







    
def confidenceIntprop2(X1List,x1,alfa,X2List,x2) :  # return int1,int2 
    p1 = proportion(X1List,x1)
    p2 = proportion(X2List,x2)
    z  = zTable(alfa/2)
    sigma = standardErrorprop2(X1List,x1,X2List,x2)
    return (p1 - p2 ) - z * sigma , (p1-p2) + z * sigma
    
    
    
    
def standardZ(xi,Xlist):
    return  (xi - mean(Xlist))/standardDeviation(Xlist)

#Z=xi -Xort/s

def standardError(X1List,X2List):
    return  pow((variance(X1List)/len(X1List) + variance(X2List)/len(X2List)),0.5)
    



def zTable(alfa):# alfa  = alfa/2     
    if alfa == 0.1 :
        return 1.28
    else:
        return 1.645
def confidenceInt(X1List,alfa,X2List='bos'): # return int1,int2
    if(X2List != 'bos'):
        s     = standardError(X1List,X2List)
        x1ort = mean(X1List)
        x2ort = mean(X2List)
        return (x1ort - x2ort) - zTable(alfa/2)*s , (x1ort - x2ort) + zTable(alfa/2)*s
    else:
         x1ort=mean(X1List)
         v    = pow( variance(X1List)/len(X1List) , 0.5 )
         
         return x1 - zTable(alfa/2) * v , x1 + zTable(alfa/2) * v
    
def testStatistics(X1List,M):
    sigma = pow( variance(X1List)/len(X1List) , 0.5)
    Xmean = mean(X1List)
    return ( Xmean - M ) / sigma
    
    
    
# tek populasyon iin z-test     
def zTestMean1(X1List,M,tail,alfa):# tail:  < , > , !=
    if(tail == '!='):
        # ift ynl iin Zbound2
        Zbound = zTable(alfa/2) #* pow( variance(X1List)/len(X1List) , 0.5)
    else:
        # tek ynl iin Zbound1
        Zbound = zTable(alfa) #* pow( variance(X1List)/len(X1List) , 0.5)
        
    Z = testStatistics(X1List,M)
    
    if(tail == '!='):
        return (-Zbound < Z < Zbound) 
    elif(tail == '<'):
        
        return -Zbound < Z 
    
    elif(tail == '>'):
        return Zbound > Z
    else :
        raise ''
     
# 2 populasyon iin z-test i     
# buradayz
def zTestMean2(X1List,tail,X2List,alfa): #
    M1 = 1
    M2 = 1
    if (tail == '!='):
        # ift ynl iin Zbound
        Zbound = zTable(alfa/2) # * standardError(X1List,X2List)
    else:
        # tek ynl iin Zbound
        Zbound = zTable(alfa)   #* standardError(X1List,X2List)
    Z = (  (mean(X1List) - mean(X2List)) - (M1 - M2 )  ) / standardError(X1List,X2List)
    
    if(tail == '!='):
        return (-Zbound < Z < Zbound) 
    
    elif(tail == '<'):        
        return -Zbound < Z 
    
    elif(tail == '>'):
        return Zbound > Z
    
    else :
        raise ''
        
def zTestProportion1(XList,Xi,prop,tail,alfa):
    Z = (proportion(XList,Xi) - prop ) / standardErrorprop1(XList,Xi)
    if tail == '!=' :# ift ynl iin Zbound
        Zbound = zTable(alfa/2)   #* standardErrorprop1(XList,Xi)
    else:# tek ynl iin Zbound
        Zbound = zTable(alfa)     #* standardErrorprop1(XList,Xi) 
    if(tail == '!='):
        return (-Zbound < Z < Zbound) 
    
    elif(tail == '<'):        
        return -Zbound < Z 
    
    elif(tail == '>'):
        return Zbound > Z
    
    else :
        raise ''
    
def zTestProportion2(XList1,XList2,X1i,X2i,tail,alfa):
    "iki populasyonun oranlarnn karolatrlmas"
    P1 = proportion(XList1,X1i)
    p2 = proportion(XList2,X2i)
    
    Z =  (p1 - p2 )/ standardErrorprop2(XList1,X1i,XList2,X2i) # Z*
    
    if tail == '!=' :# ift ynl iin Zbound
        Zbound = zTable(alfa/2)  #* standardErrorprop2(XList,Xi)
    else:# tek ynl iin Zbound
        Zbound = zTable(alfa)    #* standardErrorprop2(XList,Xi) 
    if(tail == '!='):
        return (-Zbound < Z < Zbound) 
    
    elif(tail == '<'):        
        return -Zbound < Z 
    
    elif(tail == '>'):
        return Zbound > Z
    
    else :
        raise ''
    
def diff(XListT1,XListT2):
    try:
        d = 0
        for i in range(len(XListT1)):
            d = d + ( XListT1[i] - XListT2[i] )
        d =  d / float(len(XListT1) )    
        return d
    except:
        raise 'diff'
def standardDeviationfor_t2(XListT1,XListT2):
    di =[]
    di_toplam=0
    di2_toplam=0
    for i in range(len(XListT1)):
        di.append( XListT1[i] - XListT2[i] )
        di_toplam = di[i]
        di2_toplam = di2_toplam + pow(di[i],2)
        
    Sd = pow( (di2_toplam - pow(di_toplam,2)/len(XListT1))/(len(XListT1)-1)  ,0.5)
    print 'sd=' + str(Sd)   
    return Sd
    
    
    
def standardDeviationfor_t(XListT1,XListT2):
    dbar = diff(XListT1,XListT2)
    Sd   = 0
    for i in range(len(XListT1)):
        di = XListT1[i] - XListT2[i] 
        Sd = Sd + pow(di-dbar, 2.0 )
    # for end    
    Sd = pow( Sd / float(len(XListT1)-1) , 0.5 )
    print 'dbar' + str(dbar)
    print 'sd=' + str(Sd)
    
    return Sd

                    
def tTable(s,alfa): # s: serbestlik derecesi 
    if alfa==0.025:
        return 2.12    
    
    
def tTest(XListT1,XListT2,tail,alfa):    
    "t  testi "
    dbar = diff(XListT1,XListT2)
    t = dbar / (standardDeviationfor_t(XListT1,XListT2 ) / pow(len(XListT1),0.5) )
    # t = t*
    if tail == '!=':
        "ift ynl olduu iin"
        tbound = tTable(len(XListT1)-1,alfa/2)
    else:
        "tek ynl iin"
        tbound = tTable(len(XListT1)-1,alfa)
    print 't=' + str(t)    
    if tail == '!=' :
        return -t < tbound < t 
    elif(tail == '<'):
        return -tbound < t 
    elif(tail == '>'):
        return tbound > t 
    else :#sonular true ise 'do not reject'
        raise 'tTest'

    
    
def standardDeviationforTpooled(X1List,X2List):
    "t-pooled iin standart error "
    s1 = variance(X1List)
    s2 = variance(X2List)
    n1 = len(X1List)
    n2 = len(X2List)
    
    
    tmp = ( ( ( n1 - 1 ) * s1 + (n2 -1 ) * s2 ) / float(n1 + n2  -2)  ) * ( ( n1 + n2 )/float( n1 * n2 ))
    
    return pow( tmp ,0.5)
    
    
def tForPooled(X1List,X2List):
    M1_M2 = 0
    
    m1 = mean(X1List)
    m2 = mean(X2List)
    try:
        t = ( ( m1 - m2 ) - M1_M2 )/standardDeviationforTpooled(X1List,X2List)
    except:
        if str(sys.exc_type)== 'exceptions.ZeroDivisionError':
            t = 100
        
    return t    
    
    
#birinci populasyonun varyansnn karesi ikinci populasyonun varyansnn karesine yaklak eit ise    
def tTestpooled(X1List,X2List,tail,alfa):
    n1 = len(X1List)
    n2 = len(X2List)
    s  = n1 + n2 - 2
    t = tForPooled(X1List,X2List)
    # t = t*    
    if tail == '!=':
        "ift ynl olduu iin"
        tbound = tTable(s,alfa/2)
    else:
        "tek ynl iin"
        tbound = 2 # tTable(s,alfa)
    
    if tail == '!=' :
        return -t < tbound < t 
    elif(tail == '<'):
        return -tbound < t 
    elif(tail == '>'):
        return tbound > t 
    else :#sonular true ise 'do not reject'
        raise 'tTest'
    

def X(alfa,v): 
    "ki-kare iin tablo deerleri"
    if alfa == 0.05:
        return 22.362
    else :
        return 5.892
    
        
    
def ki_kare(sigma_kare,alfa,tail):
   
    n = 14#len(XList)
    s_kare = 961 # variance(XList)
    ki_kare = ((n-1)*s_kare)/sigma_kare
    
    ki_kare_l_bound = X(1-(alfa/2),n-1)
    ki_kare_r_bound = X(alfa/2,n-1)
    
    if tail == '!=':
        return ki_kare_l_bound < ki_kare < ki_kare_r_bound
    elif tail == '<':
        return ki_kare_l_bound <  ki_kare
    elif tail == '>':
        return ki_kare < ki_kare_r_bound
      
if __name__ == '__main__':    
        
    t1 = [100,100,90,90,80,70,70,70,65,66,59,58,57,55,55,50,49]
    t2 = [100,90, 95,99,99,69,65,90,66,65,58,62,62,55,53,50,50]
    pop1 = [55,59,57,46,62,60,49,40,35,65,43,72,61,60,45,67,45,39,52,64,47,48,50,39,42,38,32,48,55,57,53,60]    
    pop2 = [68,68,66,66,66,70,67,70,70,65,69,68,65,68,66,64,65,67,68,68,68,69,79,78,70,65,69,65,67,69,71]
    #print standardError(pop1,pop2)
    #print standardDeviation(pop1)
    #print standardDeviation(pop2)
    print "##################### Z - Test ###########################"
    print "populasyon 1:" + str(pop1)
    print "populasyon 2:" + str(pop2)
    print "mean 1:"+str(mean(pop1))
    print "mean 2:"+str(mean(pop2))
    print "standart hata(1) :"+str(standardDeviation(pop1))
    print "standart hata(2) :"+str(standardDeviation(pop2))
    print "standart error   :"+str(standardError(pop1,pop2))
    print "tail(>) alfa = 0.1 \nsonu\n"
    if  zTestMean2(pop1,'>',pop2,0.1):
        print 'do not reject'
    else :
        print 'reject'
    print '######################## T - test ###########################'    
    print "populasyonu ilk hali :"+str(t1)
    print "populasyonun son hali:"+str(t2)
    print "tail(<) , alfa=0.025\nsonu\n"
    if tTest(t1,t2,'<',0.025):
        print 'do not reject'
    else:
        print 'reject'
        
    print '######################## T-pooled ############################'
    print '1.populasyon :\n'+ str(pop1)
    print '2.populasyon :\n'+ str(pop2)
    print 'standard error ' + str(standardDeviationforTpooled(pop1,pop2))
    print 'n1=' + str(len(pop1))
    print 'n2=' + str(len(pop2))
    print 'pop1 variance:'+str(variance(pop1))
    print 'pop2 variance:'+str(variance(pop2))
    print 't* =' + str(tForPooled(pop1,pop2))
    print 'tail (<) alfa=0.025 \n sonu: '
    
    if tTestpooled(pop1,pop2,'<',0.025):
        print 'do not reject'
    else :
        print 'reject'
    print '@#################################### ki-kare ####################'                           
    if ki_kare(800,0.1,'!='):
        print 'do not reject'
    else:
        print 'reject'
        
        
    
        
    i = raw_input()
