## Script (Python) "kzGetDataTree"
##parameters=RefDataId='RefData'
##bind container=container
##bind context=context
##bind namespace=_
##bind script=script
##bind subpath=traverse_subpath
##title= Referans veritabani agacini dondurur

from Products.Kuzgun import kzSort

allowedTagnames = ["group","table","field"]

def createDataTree(qref,nodeid='g0',indent=0,selectedlist=[],list_tree=[]):
    treeitem = qref.getAttributes(nodeid)
    treeitem['indent'] = indent
    treeitem['image'] = ''
    list_tree.append(treeitem)

    if treeitem['tagname'] in ['group','table']:
      if treeitem['tagid'] in selectedlist:
        childs = []
	for child in qref.getChilds(treeitem['tagid']):
	    if child["tagname"] in allowedTagnames:
		childs.append(child)
	kzSort.kzSort( [childs,("tagname","max"),("order","max")] )
        for child in childs:
	    createDataTree(qref,child["tagid"],indent+1,selectedlist,list_tree)

    return list_tree


qref = getattr(container,RefDataId,None)
if qref:
  data_selectedlist = str(context.REQUEST.get('data_selectedlist','')).split(',')
  datatree = []
  return createDataTree(qref,selectedlist=data_selectedlist,list_tree=datatree)
else:
  raise "RefData with id=%s not found" % (RefDataId)

