# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
import copy
import string
from kzObjects import *
from DateTime  import DateTime
from Products.PythonScripts.PythonScript import PythonScript

class kzJavascript:

  def __init__(self,qref,tagid,dic):
    "JavaScript nesnesi olusturur"

    self.tagname    = "javascript"
    self.tagid      = tagid
    self.attr       = self.control_attr(dic) # call,params,text
    self.qref       = qref
    
  def create_db(self,parentID):
    # Veritabani yaratilirken yapilacak islem
    return 0
    
  def insert(self,parentID):
    # Yeni bir script ekler
    tagid = self.insert_ref(parentID)
    return tagid    
  
  def insert_ref(self,parentID):
    # Yeni bir script ekler
    container = self.qref.getContainer(parentID)
    container.manage_addProduct["OFSP"].addDTMLDocument(self.tagid,title="")
    tempobj = getattr(container,self.tagid)
    tempobj.manage_edit(data=self.attr["text"],title=self.attr["params"])
    setattr(tempobj,'call',self.attr["call"])
    self.qref.addProperty(tempobj,'tagname',self.tagname,type="string")
    return "%s_%s" % (parentID,self.tagname)
    
  
  def insert_data(self,parentID):
    # Veritaban ilemi yapar
    pass
  
  def update(self,dic):
    # Script zelliklerini deitirir
    dic = self.control_attr(dic)
    tempobj = self.qref.getContainer(self.tagid)
    tempobj.manage_edit(data=self.attr['text'],title=self.attr['params'])
    setattr(tempobj,'call',self.attr["call"])
    
    
  def delete(self):
    # Script'i siler
    self.delete_ref()
    
  def delete_ref(self):
    tempobj = self.qref.getContainer(self.tagid)
    parent  = tempobj.aq_parent
    parent._delObject(tempobj.id())
    
  def delete_data(self):
    pass
    
    
  def control_attr(self,dic):
    # Script zelliklerini kontrol eder
    tempdic = {}
    tempdic['params'] = dic.get('params','')
    tempdic['text']   = dic.get('text','')
    tempdic['call']   = dic.get('call','')
    
    return control_attr(tempdic)  
  