# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
from kzObjects import *
import copy
import string
import time 

from kzObjects import *

class kzSelection:
  # Alan iin tanmlanan seim nesnesi
  
  def __init__(self,qref,tagid,dic):
    "Seim nesnesi olusturur"
    
    self.tagname    = "select"
    self.tagid      = tagid
    self.attr       = self.control_attr(dic) # selectid,text
    self.qref       = qref
    
  def create_db(self,parentID):
    # Veritabani yaratilirken yapilacak islem
    return 0
    
  def insert(self,parentID):
    # Yeni bir selection ekler
    self.tagid = self.insert_ref(parentID)
    return self.tagid    
  
  def insert_ref(self,parentID):
    # Yeni bir select ekler
    select_id = self.attr["selectid"]
    # Selectid'nin tek olmasi iin
    rec = self.qref.getChilds(parentID,"select")
    selectid_list = []
    for r in rec:
      selectid_list.append(r["selectid"])
    while select_id in selectid_list:
      select_id = select_id + "_"
    self.attr["selectid"] = select_id
    # Referansa ekle
    newID = self.qref.insertNode(parentID,"select",self.attr)
    return newID 
  
  def insert_data(self,parentID):
    # Veritaban ilemi yapar
    pass
  
  def update(self,dic):
    # Select zelliklerini deitirir
    dic = self.control_attr(dic)
    select_id = dic["selectid"]
    # Selectid'nin tek olamsi iin
    parentID = get_parent(self.tagid)
    rec = self.qref.getChilds(parentID,"select","*",["tagid","!=",self.tagid])
    selectid_list = []
    for r in rec:
      selectid_list.append(r["selectid"])
    while select_id in selectid_list:
      select_id = select_id + "_"
    dic["selectid"] = select_id
    self.attr = dic
    # Referans gncelle
    self.qref.updateNode(self.tagid,self.attr)
    
  def delete(self):
    # Select'i siler
    self.delete_ref()
    
  def delete_ref(self):
    self.qref.delete(self.tagid)    
    
  def delete_data(self):
    pass
        
    
  def control_attr(self,dic):
    # Select zelliklerini kontrol eder
    dic = copy.deepcopy(dic)
    # Attr dzgn gelmis mi?
    if (not dic.has_key("selectid")) or \
       (not dic.has_key("text")):
      if not dic.has_key("selectid"):
        dic["selectid"] = string.split(str(time.time()),".")[0]
      if not dic.has_key("text"):
        dic["text"] = ""
        
    if dic["selectid"] == "":
      dic["selectid"] = string.split(str(time.time()),".")[0]
      
    dic["tagname"] = self.tagname  
    dic["deleted"] = "0"
    
    return control_attr(dic)