# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
from kzObjects import *
import copy
import string
import time 

from kzObjects import *

class kzTableTransitions:
  # Alan iin tanmlanan seim nesnesi
  
  def __init__(self,qref,tagid,dic):
    "Tablo Gei nesnesi olusturur"
    
    self.tagname    = "table_trans"
    self.tagid      = tagid
    self.attr       = self.control_attr(dic) # state , destination , title , description , priority , deadtime
    self.qref       = qref
    
  def create_db(self,parentID):
    # Veritabani yaratilirken yapilacak islem
    return 0
    
  def insert(self,parentID):
    # Yeni bir selection ekler
    self.tagid = self.insert_ref(parentID)
    return self.tagid    
  
  def insert_ref(self,parentID):
    # Yeni bir select ekler
    # Referansa ekle
    newID = self.qref.insertNode(parentID,"table_trans",self.attr)
    return newID 
  
  def insert_data(self,parentID):
    # Veritaban ilemi yapar
    pass
  
  def update(self,dic):
    # Select zelliklerini deitirir
    # Referans gncelle
    self.qref.updateNode(self.tagid,self.attr)
    
  def delete(self):
    # Select'i siler
    self.delete_ref()
    
    
  def delete_ref(self):
    self.qref.delete(self.tagid)    
    
  def delete_data(self):
    pass
        
    
  def control_attr(self,dic):
    # Select zelliklerini kontrol eder
    temp_dic = {}
    temp_dic['state']       = dic.get('state','')
    temp_dic['destination'] = dic.get('destination','')
    temp_dic['title']       = dic.get('title','Task')
    temp_dic['description'] = dic.get('description','-')
    temp_dic['priority']    = dic.get('priority','0')
    temp_dic['deadtime']    = dic.get('deadtime','0')
    
    return control_attr(temp_dic)
  
  
  