# -*- coding: utf-8 -*-
from config import *
from AccessControl import ClassSecurityInfo
from Translateable import Translateable
from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate
from Products.PythonScripts.PythonScript import PythonScript
import string
import sys

schema = BaseSchema + Schema((
    
    StringField('scriptParams',
                widget=StringWidget(label_msgid="label_scriptparams",
                                    description_msgid="help_scriptparams",
                                    label='Script Parameters',
                                    i18n_domain=i18n_domain),
                ),
  
    TextField('scriptText',
              widget=TextAreaWidget(label_msgid="label_scripttext",
                                    description_msgid="help_scripttext",
                                    label='Script Text',
                                    rows=40,cols=60,
                                    i18n_domain=i18n_domain),
              ),
    ))

class kzJavaScript(BaseContent,Translateable):
    """kzJavaScript """
    
    schema = schema
    
    meta_type = 'kzJavaScript'
    archetype_name = "Kuzgun Java Script"
    tagname="javascript"
    
    actions = (
        
        {
            'id': 'javascript_test',
            'action': 'string:$object_url/kzjavascript_test',
            },
        )
    
    global_allow = 0
    filter_content_types = 1
    allowed_content_types = []
    
    security = ClassSecurityInfo()
    
    def __init__(self, oid, tableid="", **kwargs):
        BaseContent.__init__(self,oid,**kwargs) 
        
    def javaScriptView(self):
        return {"scriptname"  : self.getId(),
                "scriptparams": self.getScriptParams(),
                "scripttext"  : self.getScriptText()   
                }
    
    
registerType(kzJavaScript, PROJECTNAME)
