# -*- coding: utf-8 -*- 
from kzFields import *
import string


class kzOntimeScript:
  #Alan icin tanimlanan script'i calistirir
  def __init__(self,script,qref,tableid):
    self.tableid    = tableid 
    self.script     = script
    self.params     = qref.getChilds(tableid,"param")
    self.error      = ""
    
  def calculate(self,form_values={}):
    # Scriptin parametrelerini bulur ve hesaplar
    tableid = self.tableid
    
    if self.script is None:
      return None
    
    else:
      kzPrmDic={} # Degiskenleri tutar
      scripttext = getattr(self.script,'_params')
      control    = 0
      if len(scripttext) == 0:
        params = "tableid,form_values"
        control = 1
      elif scripttext.find("form_values") < 0:
        params = "tableid,form_values,%s" % (scripttext)
        control = 1
        
      if control:
        text = getattr(self.script,'_body')
        self.script.ZPythonScript_edit(params, text)  
        
      scripttext = getattr(self.script,'_params')

      for param in self.params:
        paramname = param["paramid"]
        fieldid   = param["fieldrelation"]
        scripttext = string.replace(scripttext,'%s' % (paramname),"'%s'" % (fieldid) )
        
      try:  
        eval("self.script(%s)" % (scripttext) )
      except:
        except_string = str(sys.exc_type) +":"+str(sys.exc_info)
        self.error    = "error %s : script= %s : error= %s" % (self.tableid,scripttext,except_string)

        
