## Script (Python) "add_kzTask"
##parameters=
##bind container=container
##bind context=context
##bind namespace=_
##bind script=script
##bind subpath=traverse_subpath
##title=Belirtilen kullanıcıya görev atanır

from DateTime import DateTime

year  = context.REQUEST.get('deadtime_year','')
month = context.REQUEST.get('deadtime_month','')
day   = context.REQUEST.get('deadtime_day','')

title       = context.REQUEST.get('title','')
destination = context.REQUEST.get('destination','')

deadtime = "%s/%s/%s" % (year,month,day)

try:
  d = DateTime(deadtime)
  context.REQUEST.set('deadtime',deadtime)
  if not title:
    err_msg = "?portal_status_message=Please enter a valid title"
    url = 'kzTask_add' + err_msg
  elif not destination:
    err_msg = "?portal_status_message=Please enter a valid destination"
    url = 'kzTask_add' + err_msg
  else:
    context.kzTaskManager.add(context.REQUEST)
    url = 'kzTask_outbox'
except:
  err_msg = "?portal_status_message=Please enter a valid date" + deadtime
  url = 'kzTask_add' + err_msg

context.REQUEST.RESPONSE.redirect(url)


