import sys

digitOne={"0":"zero","1":"One","2":"Two","3":"Three","4":"Four","5":"Five","6":"Six","7":"Seven","8":"Eight","9":"Nine"}
digitTen={"2":"Twenty","3":"Thirty","4":"Forty","5":"Fifty","6":"Sixty","7":"Seventy","8":"Eighty","9":"Ninety"}
digit10_20={'10':'Ten','11':'Eleven','12':'Twelve','13':'Thirteen','14':'Fourteen','15':'Fifteen','16':'Sixteen','17':'Seventeen','18':'Eighteen','19':'Nineteen'}

def read(str):
    "(0-10) aralndaki saylar okur"
    if  0 < int(str) and int(str) <= 9:
        return digitOne[str]
    return ""

def read_decimal(str):
    "(10-99) onlar hanesini okur"
    if  0 < int(str) and int(str) <= 9:
        return digitTen[str]
    return ""

def read3(str):
    "c haneli saylar okur"
    result = ""
    result = read(str[0])    
    if result != "":
        result = result + "Hundred"
    if( 10 <= int(str[1:3]) < 20 ):
        result = result + digit10_20[str[1:3]]
    else:
        result = result + read_decimal( str[ 1 ] ) + read( str[ 2 ] )
    return result

def add(str,digit,space):
    "readnan 3 haneli saylarn sonuna basamak deerini ekler(milyon , bin gibi)"
    result = read3( str ) 
    if result != "":
        return result + space + digit + space
    return ""

def write(numeric,space):
    "para miktarn yaz ile ifade eder"
    numeric = str(float(numeric)).split('.')[0]
    result=""				
    while len(numeric)%3 != 0 :  # basamak saysn 3 n kat olacak ekilde baa sfr ekler
        numeric = "0" + numeric
    while 1:			
        digit = len( numeric )
        if digit==18 :#18 haneli ise
                
                result = result + add(numeric[:3],"quadrillion",space)
        elif digit==15:
                result = result + add(numeric[:3],"trillion",space)
        elif digit==12:
                result = result + add(numeric[:3],"billion",space)
        elif digit==9:
                result = result + add(numeric[:3],"million",space)
        elif digit==6:
                result = result + add(numeric[:3],"thousand",space)
        elif digit==3:
                result = result + read3(numeric[:3])
        else :
                break
        numeric = numeric[3:]        
    return result
'''
def monetaryWrite(numeric):
    "para formatnda yazdr"   
    numeric = str(numeric)
    numeric = numeric.split('.')
    length  = len( numeric[0] )
    if( (length % 3 != 0 ) and length > 3 ) :
        step = length / 3 
    elif length % 3 == 0:
        step = length / 3 - 1
    else :
        step = 0        
    for i in range(step):
        numeric[0] = numeric[0][0:length - (i+1)*3] + thousand_sperator + numeric[0][-(i*3+3+i):]
    if numeric[1]=='0':
        return numeric[0]    
    else :
        return numeric[0] + decimal_point + numeric[1]

def out(numeric,format,space):
    if format == 'NUMERIC':
        numeric = str(numeric)  #float geer dnyor
        if numeric[-2:] == '.0':
            numeric = numeric[:-2]  # sonundaki .0 silindi
        return numeric
    
    elif format == 'STRING':
        return write(numeric , space)
    
    elif format == 'MONETARY':
        return monetaryWrite(numeric)
    
    else:
        raise 'kzMoney.out:Desteklenmeyen format parametresi'  
                
def test():
    print out(232334456789.0,'STRING','   ')
    i = raw_input()
        
if __name__ == '__main__':    
    test()    
        '''
