# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*-
#  Project Name      :Kibele E- Platformu
#  Modul   Name      :kzString snf
#  Hedefleri         :temel string fonksiyonlar
#  Developer         :Okan Akbulut
#  Copyright         :ANKA Bilgi Teknolojileri 2002
#  Kullanm Haklar  :Her Hakk Sakldr
#  Conditions        :
#  Files             :hece.txt
#---------------------------------------------------------------------------------------    
#  History                :   Date      Version      Developer      Deiiklikler 
#                          2003/04/29              Okan AKBULUT     utf8 uyumlulugu      
import string
#import linecache
import sys
#import rotor

utf8Totr = { '\xc4\xb1':'','\xc4\x9f':'','\xc3\xbc':'','\xc5\x9f':''\
	     ,'\xc3\xb6':'','\xc3\xa7':'','\xc4\x9e':'','\xc3\x9c':''\
	     ,'\xc5\x9e':'','\xc4\xb0':'','\xc3\x96':'','\xc3\x87':''\
	     ,'305;':'','304;':'','287;':'','286;':'','351;':'','350;':''
	   }

trToutf8 = { '':'\xc4\xb1','':'\xc4\x9f', '':'\xc3\xbc','':'\xc5\x9f'\
	    ,'':'\xc3\xb6', '':'\xc3\xa7','':'\xc4\x9e', '':'\xc3\x9c'\
	    ,'':'\xc5\x9e','':'\xc4\xb0', '':'\xc3\x96', '':'\xc3\x87'
	   }

def utf8_to_tr(s):
  length = len(s)
  i = 0
  _str = ''
  while(i < length):
    if s[i:i+2] == '&#':
      i += 2
      try:
	_str += utf8Totr[s[i:i+4]]
	i += 4
      except KeyError:
	_str += '&#'
      #end try
    else:
      try:
	_str += utf8Totr[s[i:i+2]]
	i += 2
      except KeyError:
	_str += s[i]
	i += 1      
      #try
  #end while
  return _str

def tr_to_utf8(s):
  length = len(s)
  i = 0
  _str = ''
  while(i < length):
    try:
      _str += trToutf8[s[i]]      
    except KeyError:
      _str += s[i]      
    #try
    i += 1      
  #end while
  return _str

tr_map =[("&#305",""),("&#287",""),("&#351",""),("&#304",""),("&#286",""),("&#350","")]
def utf8_to_trx(s):
  n= len(tr_map)
  
  for i in range(n):
    utf8,tr = tr_map[i]
    s = string.replace(s,utf8,tr)
  return s
  
def tr_to_utf8x(s):
  n= len(tr_map)
  
  for i in range(n):
    utf8,tr = tr_map[i]
    s = string.replace(s,tr,utf8)
  return s


def abbreviation(kzString,length):   
    kzString.alltrim()  
    l = kzString.len()
    if length < l : #kzString.len() :        
        level1(kzString,length)
    #fi

def level1(kzString,length):
    "ilk heceleri al"                     
    diff   = kzString.len() - length
    kzString.syllable()
    words  = kzString.split()
    indx   = len(words) - 1
    
    while indx != -1:
        delete      = string.split(words[indx],'-')[1:]
        delete      = string.join(delete,'')
        words[indx] = string.split(words[indx],'-')[0]        
        lendelete   = len(delete) 
        if delete != [] and delete != '':
            words[indx] = words[indx] + '.'
            lendelete   = lendelete - 1        
        #fi    
        diff = diff - lendelete
        if diff > 0:
            indx = indx - 1
            continue
        else :
            kzString.join(words)
            kzString.remove('-')
            return
    kzString.join(words)
    level2(kzString,diff)      
                    
def level2(kzString,diff):
    "boluklar sonra seslileri at"
    length = kzString.len()
    kzString.replace('. ','.')
    diff   = diff - (length - kzString.len())
    if diff > 0 :            
        indx = kzString.len() - 1        
        while indx != -1:            
            # sesli hecenin banda deilse sil
            if kzString.isVovel(indx) != -1 and indx != 0:
                if (kzString[ indx-1 ] != " " and kzString[indx-1]!='.'):                
                    kzString.s  = kzString[:indx] + kzString[indx+1:]
                    diff = diff-1
                #fi    
            if diff > 0:
                indx = indx - 1 
                continue
            return 
    #fi
    level3(kzString,diff)	       
        
def level3(kzString,diff):
    "sadece bas harfleri al"    
    words = kzString.split()
    indx = len( words ) - 1
    
    while(indx != -1 and diff > 0):			
        boy = len( words[indx] )
        words[indx] = words[indx][0]
        diff = diff - (boy - 1)
        if diff > 0:
            indx = indx-1
            continue
        else :
            kzString.join(words,'.')
            return     
        
    kzString.join(words,'.')    
    level4(kzString,diff)  
           
def level4(kzString,diff):
    "Noktalar kaldr gerekirse sondan kes"
    length = kzString.len()
    kzString.remove(' ',diff)
    diff  = diff - (length - kzString.len() )
    
    if diff > 0 : 
        length = kzString.len()
        kzString.reverse()
        kzString.remove('.',diff)
        kzString.reverse()
        diff = diff - ( length - kzString.len() )
        if diff > 0 :
            kzString.s = kzString[:-diff]        
                
class kzString:
    s = ""
        
    def __init__(self,str,Language = "turkce"):        
        try:
            try: str = str.encode("iso-8859-9")
	    except: pass
            self.setLanguage(Language)
	    if Language == 'turkce':
	      self.s = utf8_to_tr(str)

        except :
            raise 'kzString.__init__:'      
            
    def __str__(self):    		
        return self.s      
                
    def __getitem__(self,i):
        "s[i]"
        try:
            return self.s[i]
        except:
            print i,self.len()
           #raise str(sys.exc_type) + '|kzString.__getitem__:'
       
    def __setitem__(self,i,v):
        "s[i]=v"
        try:
            self.s = self.s[:i] + str(v) + self.s[i:] 
        except:
            raise sys.exc_type + '|kzString.__setitem__:'
        
    def __getslice__(self,i,j):
        "s[i:j]"
        try:
            return self.s[i:j]
        except:
            raise sys.exc_type + '|kzString.__getslice__:'
    def __setslice__(self,i,j,seq):
        "s[i:j]=seq   [i,j)"
        try:
            self.s = self.s[:i] + str(seq) + self.s[j:]      
        except:
            raise sys.exc_type + '|kzString.__setslice:'
        
    def __delslice__(self,i,j):
        "del s[i:j]    [i,j)"
        try:
            self.s = self.s[:i] + self.s[j:]
        except:
            raise sys.exc_type + '|kzString.__delslice__:'        
            
    def __concat__(self,other):
        "self + other "
        try:
            return self.s + str(other)
        except:
            raise sys.exc_type + '|kzString.__concat__:'
    def __len__(self):
        return len(self.s)
       
    def lower(self):
        "kk harfe evirir"
        self.s = self.loc.lower(self.s)
                
    def upper(self):
        "byk harfe evirir"
        self.s = self.loc.upper(self.s)
        
    def swapcase(self):
        "byk harfleri ke, kk harfleri bye evirir"
        self.s = string.swapcase(self.s)
     
    def split(self,sep=None):
        return string.split(self.s,sep)
    
    def join( self,list,sep=' '):
        
        self.s = string.join(list,sep)
        
    def strip(self):
        "sadan ve soldan boluklar al"
        self.s = string.strip(self.s)
        
    def lstrip(self):
        "bataki boluklar al"
        self.s = string.lstrip(self.s)
    
    def rstrip(self):
        "sondaki boluklar al"
        self.s = string.rstrip(self.s)        
        
    def find(self,sub,case_sensitive=1):
        "aranan stringin batan itibaren konumu, bulunamazsa -1 dner"
        try:
            if(case_sensitive == 1):
                s = self.s
            else:
                s   = self.loc.lower(self.s)
                sub = self.loc.lower(sub)            
            return string.find(s,sub)                          
        except:
            raise sys.exc_type + '|kzString.find:'
        
    def rfind(self,sub,case_sensitive=1):  
        "verilen stringin sondan itibaren varsa indexi yoksa -1"
        try:
            if(case_sensitive == 1):
                s = self.s
            else:
                s   = self.loc.lower(self.s)
                sub = self.loc.lower(sub)
            return string.rfind(s,sub)            
        except:  
            raise sys.exc_type + '|kzString.rfind:'
        
    def count(self,sub,case_sensitive=0):
        'verilen stringin says'
        try:
            if(case_sensitive == 1):
                s = self.s
            else:
                s   = self.loc.lower(self.s)
                sub = self.loc.lower(sub)
            return string.count(self.s,sub)
        except:  
            raise sys.exc_type + '|kzString.count:'
        
    def wcount(self,sub,case_sensitive=0):
        'verilen kelimenin says'
        wList = self.split()
        
        if case_sensitive == 0:
            sub = self.loc.lower(sub)            
            for i in range(len(wList)):
                wList[i] = self.loc.lower(wList[i])
        #fi
        return wList.count(sub)

    def ljust(self,width):
        "sola yasl boyu width olana kadar uzatr"
        try:
            self.s = string.ljust(self.s,width)
        except:
            raise sys.exc_type + '|kzString.ljust:'
            
    def rjust(self,width):
        "saa yasl boyu width olana kadar uzatr"
        try:
            self.s = string.rjust(self.s,width)
        except:
            raise sys.exc_type + '|kzString.rjust:'
        
    def center(self,width):
        "ortal, boyu width "
        try:
            self.s = string.center(self.s,width)
        except:
            raise str(sys.exc_type) + '|kzString.center:'

    def zfill(self,width):
        "stringin boyu width olana kadar bana 0 koyar"
        try:
            self.s = string.zfill(self.s,width)
        except:
            raise str(sys.exc_type) + '|kzString.zfill:'
        
    def capitalize(self):
        '''0. karakter harf ise byk harfe evirir
         gerisini kk harfe evirir'''
        try:
            self.s = string.capitalize(self.s)
        except:
            raise str(sys.exc_type) + '|kzString.capitalize:'
        
    def capwords(self,sep = None):
        '''ayra ile ayrlan kelimelerin ba harfini byk 
           geri kalann kk harfe evirir'''
	if self.Language == 'turkce':
            #self.alltrim()
            wl = []
            for word in self.split(sep):
                word = self.loc.upper(word[0])+self.loc.lower(word[1:])
                wl.append(word)
            self.join(wl)
        else:
            self.s = string.capwords(self.s,sep) 

    def alltrim(self):
        "kelimeler arasndaki boluklar tek bolua indir"   
        self.join(self.split())


    def replace(self,old,new,maxsplit=-1,case_sensitive=0):
    	"string ierisinde geen bir stringi yenisiyle deitirir"
        try:
            if(case_sensitive == 1):
                self.s = string.replace(self.s,old,new,maxsplit=-1)
            else:
                s      = self.loc.lower(self.s)
                old    = self.loc.lower(old)
                self.s = string.replace(s,old,new,maxsplit)
            #fi           
        except:
            raise sys.exc_type + '|kzString.replace:'
       
    def remove(self,sub,maxsplit=-1,case_sensitive=0):    
      try:
          if case_sensitive == 0:                 
              s      = self.loc.lower(self.s)
              sub    = self.loc.lower(sub)
              self.s = string.replace(s,sub,'',maxsplit)
          else:
              s = self.s
          #fi
          self.s = string.replace(s,sub,'',maxsplit)
      except:
          raise sys.exc_type + '|kzString.remove:'

                                        
    def reverse(self,word=0):
        '''stringi ters evirir 
        word = 1 ise kelimeleri bozmadan dizililerini ters evirir'''
  
            
        if word == 0 :#stringin tersini al
            boy  = len(self.s) 
            indx = boy-1
            while indx != -1:
                self.s = self.s+self.s[indx] 
                indx   = indx-1
            self.s = self.s[boy:] 			
        else :   # kelimeleri bozmadan srasn deitir 
            liste  = string.split(self.s)
            liste.reverse()
            self.s = string.join(liste) 
            
    def wReplace(self,str1,str2,case_sensitive=0):
        'verilen birinci kelimeyi ikinci ile deitirir'
        wList  = self.split()        
        for  i in range(len(wList)):
            if case_sensitive == 1:
                wList[i] = self.loc.lower(wList[i])
                str1     = self.loc.lower(str1)
            if wList[i]  == str1 :
                wList[i] = str2
        #fi        
        self.join(wList)          
            
    def isEmpty(self):
        "string bomu"
        return self.s == ''
            
    def isAlpha(self,indx=-1):
        "stringin tamam alfabetik karakterlerdenmi oluuyor"
        s  = self.loc.lower(self.s)
        if indx != -1 :
            ch = s[indx]
            return self.loc.isAlpha(ch) 
        else:
            for ch in s :
                if not self.loc.isAlpha(ch):
                    return 0
                #fi
            return 1    
        
    def isDigit(self):
        "string digitlerdenmi oluuyor"
       
        for ch in self.s :
            if not( '0' <= ch <= '9'):
                return 0
        return 1
    
    def isVovel(self,indx): 
        "indx ile gsterilen harf  seslimi"            
        return self.loc.isVowel(self[indx])
    
    def syllable(self) :
        "stringi heceler, hecelerin arasna - koyar"
            
        self.s = self.loc.syllable(self.s)
                    
    def gramer(self):	
        "noktalama iaretlerinin imla  kurallarna uygunluunu denetler"
            
        self.s = self.loc.gramer(self.s)
            
    def haltak(self,hal = "iye",tur = ""): 
        " ismin hallerini takar"            
        return self.loc.haltak(self.s,hal,tur)
    
    def crypt(self,key="enigma"):
        "stringi verilen key ile ifreler "
        enigma = rotor.newrotor(key,12)
        self.s = enigma.encrypt(self.s)
        del enigma
            
    def decrypt(self,key="enigma"):
        "verilen key ile stringin ifresini zer"
        enigma = rotor.newrotor(key,12)
        self.s = enigma.decrypt(self.s)
        del enigma 		
    def abbreviation(self,length):
        "stringin boyu length e eit olana kadar stringi ksalt"       
        abbreviation(self,length)            
    
    def len(self):
        "stringin boyunu verir"
        return len(self)

    def left(self,indx):
        "stringin bandan indx  kadar karakter dndrr"
        if( type(indx)==type(1) and   0 < indx <= len(self.s)):
            return self[:indx]
        return ''	
    
    def right(self,indx):
        "stringin sonundan indx kadar karakter dndrr"
        if (type(indx)==type(1)) and (  0 < indx <= len(self.s)):
            return self[self.len()-indx:]
        return ''
    
    def out(self):
      if self.Language == 'turkce':
	return tr_to_utf8(self.s)
      return self.s
    
    def setLanguage(self,Language="english"): 
        " dili deitir"           
        if Language == "english" :
            
            try:
                import english
                self.loc  = english
                self.Language = "english"
            except:
                raise'kzString.setLanguage:english.py import edilemiyor'            
        else :            
            try :
                import turkce
                self.loc  = turkce
                self.Language = "turkce"
            except :
                raise 'kzString.setLanguage:turkce.py import edilemiyor'               
                          
if __name__=="__main__":
    s=kzString('ehliyeti var m?')    
#    s.syllable()
    s.abbreviation(8)  
    s.capitalize()
    s.center(10)
    print s.isAlpha()
    
    print s.out()
    i=raw_input()


 
                
                
                
                
