import linecache
import string
vowel="aeouiAEOUI"
tr_low = "i"
tr_upper="I"
utf8_tr_low   = ['\xc3\xa7','\xc4\x9f','\xc4\xb1','i'        ,'\xc3\xbc','\xc3\xb6','\xc5\x9f']
utf8_tr_upper = ['\xc3\x87','\xc4\x9e','I'        ,'\xc4\xb0','\xc3\x9c','\xc3\x96','\xc5\x9e']

def lowerx(str):# kk harfe evir
    i      = 0
    s      = ''
    length = len(str)
    while(i < length):
        if str[i:i+2] in utf8_tr_upper :
            index = utf8_tr_upper.index(str[i:i+2])
            s += utf8_tr_low[index]
            i +=2
        elif str[i] == 'I':
            s += '\xc4\xb1'
            i += 1
        else:
            s += str[i].lower()
            i += 1
        #fi
    #end while
    return s

def lower(str): # kk harfe evir
    i = 0
    end = len(str)
    while i != end:
        k = string.find( tr_upper,str[ i ] )
        if k != -1:
            str = str[:i] + tr_low[k] + str[i+1:]
            i = i + 1
            continue
        str = str[:i] + string.lower(str[i]) + str[i+1:]
        i = i + 1
    return str	


def upperx(str):# buyuk harfe evir
    i      = 0
    s      = ''
    length = len(str)
    while(i < length):
        if str[i:i+2] in utf8_tr_low :
            index = utf8_tr_low.index(str[i:i+2])
            s += utf8_tr_upper[index]
            i +=2
        elif str[i] == 'i':
            s += '\xc4\xb0'
            i += 1
        else:
            s += str[i].upper()
            i += 1
        #fi
    #end while
    return s


def upper(str):#byk harfe evir
    i=0
    end = len(str)
    while i != end:
        k = string.find(tr_low,str[i])
        if k != -1:
            str = str[:i] + tr_upper[k] + str[i+1:]
            i = i + 1
            continue
        str = str[:i] + string.upper(str[i]) + str[i+1:]
        i = i + 1		
    return str
    
def isVowel(strng):# sesli mi
    if type(strng) != type("string"):
        strng = str(strng)
    return string.find(vowel,strng)

def isAlpha(ch):#girilen karakter alfabetikmi
    try:       
        ch    = lower(ch)	
        alpha = string.lowercase + tr_low
        
        return string.find(alpha,ch) != -1
    except:
        raise 'kzString.isAlpha:'
    
def count(str,ch="lower"): # str iindeki kk harf veya byk harf says 
    if ch == "lower" or ch == "kucuk":
        search  =  string.lowercase + tr_low
    else :
        search  =  string.uppercase + tr_upper		
    count = 0
    for ch in str:
        if string.find(search,ch) != -1:
            count  =  count+1
    return count

def isSyllable(str): # str geerli bir hecemi
# 
    linecache.getlines('hece.txt')
    s  =  linecache.cache.values()#donen deger bir tupple s[0][2] bir liste (dosya icerigi)
    s  =  " " + string.join(s[0][2]) + " "
    return string.find(s," "+str+" ")

def isword(str):#girilen kelimenin heceleri hece ktphanseinde varsa geerli bir kelimedir
    s     = syllable(str)	
    start = -1
    if string.count(s,"-") != 0:
        end  =  string.find(s,"-")
        while  start != -1 or end != -1:
            if end != -1:
                if isSyllable(s[start+1:end]) == -1:
                    return -1
            else :
                if isSyllable(s[start+1:len(s)]) == -1:
                    return -1
            temp  =  end
            end   =  string.find(s,"-",start+1,len(s)-1)
            start =  temp
            return 1
    else :
        return isSyllable(s)	
    
def erase(str,ch=".",dot_count=-1):	
    start  =  string.find(str,ch)
    while dot_count != 0 and start != -1:		
        str      =  str[:start]+str[start+1:]
        dot_count=  dot_count-1
        start=string.find(str,ch,start)
    return str 	

def dot_check(str):# string iinde nokta ve nokta varsa ne yaplacana karar verilir
    dot_count  =  string.count(str,".")
    if dot_count > 1:
        if float(len(str))/float(dot_count) == 2.0:
            i  =  1
            while i <= len(str):
                if str[i] != ".":
                    return erase(str,".",dot_count),0,0,"",0
                i = i + 2
            str  =  upper(str)      
            return str,0,0,"",0	
        else :
            uc_nokta  =  string.find(str,"...")
            if uc_nokta != -1:
                if len(str)-3-string.rfind(str,"...") == 0 :
                    return erase(str,".",dot_count-3),1,0,"",0
                elif uc_nokta == 0:
                    str = "..."+erase(str,".")
                    return str,0,0,"",0
                else :
                    str  =  erase(str[:uc_nokta])+"..."+erase(str[uc_nokta+3:])
                    return str,0,0,"",0
                    
                
            elif len(str)-1-string.rfind(str,".") == 0 :
                return erase(str,".",dot_count-1),1,0,"",0
            else :
                return erase(str),0,0,"",0
    elif dot_count == 1:
        
        if str[len(str)-1] == "." :
            if isword(str[:-1]) == -1:
                #str=string.upper(str[0])+str[1:]
                return str,0,0,"",1
            return str,1,0,"",0			
        elif str[0] == ".":
            return str[1:],0,0,".",0
        else :
            nokta = string.find(str,".")
            if isword(str[:nokta]):#==-1 i kontrol et
                
                return str,1,string.find(str,"."),"",0
            erase(str)
            return str,0,0,"",0
    else :
        return str,0,0,"",0	
    
def comma_check(str):#string iinde virgl veya nuktal virgl varsa ne yaplacana karar verir
    for ch in ",;" :		
        count  =  string.count(str,ch)
        if count == 1 :
            if str[0]==ch:
                return str[1:],0,ch
            elif str[len(str)-1]==ch:
                return str,0,""
            else :
                virgul  =  string.find(str,ch)
                if isword(str[:virgul])==-1:
                    str = erase(str,ch)					
                    return str,0,""				
                return str,virgul,""
        elif count > 1:
            str = erase(str,ch)
            return str,0,""
        else:	
            continue
    return str,0,""		

def terminator(str,sentence):
    for ch in ":?!":
        
        ch_count  =  string.count(str,ch)
        if ch_count != 0 :
            if ch_count > 1:
                str = erase(str,ch,ch_count-1)
            position  =  string.find(str,ch)
            if position == 0:
                return str[1:],sentence,0,ch
            elif position == len(str)-1:
                return str,1,0,""
            else :	
                return str,sentence,position,""
    return str,sentence,0,""		

def duzelt(str,end_sentence,abbreviation):#genel olarak ba harfi byk dierlerini kk yapar
    if count(str,"buyuk") >= count(str,"kucuk"):
        str = upper(str)
#		
    elif count(str[0],"buyuk")==1 or end_sentence==1 or abbreviation==1:
        str=upper(str[0]) + lower(str[1:])
        
    else :
        str=lower(str)
        
    return str

def update(words,i,last,defrag):
    #bir onceki kelimeyle ilgili deiiklikleri yapar
    if last  !=  "" and  i > 0  and  string.find(".,?!:; \" '   ",words[i-1][len(words[i-1])-1]) == -1:
        words[i-1]  =  words[i-1] + last		
        return words,-1
    if defrag != 0 :#kelime paralanaca zaman
        liste = [""]
        liste[0] = words[i][defrag+1:]
        if string.find(".,?!:; \" '",liste[0]) == -1:
            words = words[:i+1]+liste+words[i+1:]
        words[i] = words[i][:defrag+1]			
        return words,0	
    return words,1	
        


def find_vowel(str,reverse=0):# stringin bandn veya sonundan balyarak ilk seslinin konumunu bulur	
    if reverse == 0:
        i = 0
        while i != len(str):
            k = string.find(vowel,str[i]) 
            if k != -1 :
                return  i
            i = i + 1 
    else :
        i = len(str)-1
        while i != -1 :
            k  =  string.rfind(vowel,str[i])
            if k != -1:
                return i
            i = i - 1 
    return 0	
def haltak(str,hal="i",tur=""):# ismin hallerini takar
    if type(str) != type("string"):
        return -1
        #error
        
    mdfy_vowel="iuuiIUUI"
    i_vowel="ei"
    if(hal=="i"or hal=="e" or hal=="de" or hal =="den" or hal=="iye") and (tur=="c" or tur=="") and str != "" :	
        end = len(str)-1
        while (isVowel(str[end])==-1) and (end!=-1):
            end = end - 1
        if end != 0 :
            if hal == "iye" or hal == "i":
                if hal == "iye":
                    if isVowel(str[len(str)-1]) != -1:
                        hal  = "ninki"
                    else :
                        hal = "inki"
                    if tur=="":
                        hal = "'" + hal
                else :
                    if isVowel(str[len(str)-1]) != -1:
                        hal = "y" + hal
                    if tur=="":
                        hal = "'" + hal
                k   = find_vowel(hal) 		
                hal = hal[:k]+mdfy_vowel[string.find(vowel,str[end])]+hal[k+1:]		
            else :
                if hal == "e" and isVowel(str[len(str)-1]) != -1:
                    hal= "y" + hal
                if tur=="":
                    hal = "'" + hal 
                k = find_vowel(str,1)
                if string.find(i_vowel,str[k]) == -1 :		
                    k   =  find_vowel(hal)    		
                    hal =  hal[:k]+"a"+hal[k+1:]
        
            return str+hal	
        return str 
    return str	
    
    
    
def syllable(words) :#stringi heceler, hecelerin arasna - koyar
        
        words = string.split(words)
        i     = 0
        while i != len(words):
            #a=words[i]
            j    = 0
            count= 0
            while j != len(words[i]):				
                if isVowel(words[i][j]) != -1 : #sesli harf ise
                    count  =  count+1
                    if j>0 and isVowel(words[i][j-1]) != -1:
                        words[i]  =  words[i][:j]+"-"+words[i][j:]
                        j  =  j + 1
                    elif (j>1 and count>1) and (isAlpha(words[i][j-1]) != 0 and isAlpha(words[i][j-2]) != 0):
                        
                        words[i] = words[i][:j-1] + "-" + words[i][j-1:]
                        j  = j + 1						
                j  = j + 1
            i  = i + 1
        return string.join(words)	
             
        
def gramer(words):	#noktalama iaretlerinin turke kurallara uygunluunu denetler  	
        
        words  = string.split(words)
        #self.s = loc.imla(words)		
        i  = 0
        end_sentence = 1
        
        while i!=len(words):
            boy=len(words[i])
            #nokta kontrolu
            words[i],sentence,defrag,last,abbreviation=dot_check(words[i])
            words,step=update(words,i,last,defrag)
            if step != 1:
                i = i + step
                continue			
            #virgul kontrolu	
            words[i],defrag,last = comma_check(words[i])
            words,step = update(words,i,last,defrag)
            if step != 1:
                i = i + step
                continue
            #   " : ! ? " kontrolu	
            words[i],sentence,defrag,last=terminator(words[i],sentence)	
            words,step = update(words,i,last,defrag)
            if step !=1:
                i = i + step 
                continue
                        
                
            if boy != len(words[i]):
                continue
            words[i] = duzelt(words[i],end_sentence,abbreviation)	
            abbreviation = 0
            
            i = i + 1
            end_sentence  = sentence
        return  string.join(words)	
    
    
    
    
    
