# -*- coding: utf-8 -*- 
# -*- coding: utf-8 -*- 
from kzObjects import *
import copy
import string
import time

from kzObjects import *

class kzParameter:
  # Alan iin tanmlanan parametre nesnesi
  
  def __init__(self,qref,tagid,dic):
    "Seim nesnesi olusturur"
    
    self.tagname    = "param"
    self.tagid      = tagid
    self.attr       = self.control_attr(dic) # paramid,fieldrelation,paramtype
    self.qref       = qref
    
  def create_db(self,parentID):
    # Veritabani yaratilirken yapilacak islem
    return 0  
    
  def insert(self,parentID):
    # Yeni bir grup ekler
    self.tagid = self.insert_ref(parentID)
    return self.tagid    
  
  def insert_ref(self,parentID):
    # Yeni bir parametre ekler
    param_id = self.attr["paramid"]
    rec = self.qref.getChilds(parentID,"param")
    paramid_list = []
    for r in rec:
      paramid_list.append(r["paramid"])
    while param_id in paramid_list:
      param_id = param_id + "_"
    self.attr["paramid"] = param_id
    newID = self.qref.insertNode(parentID,"param",self.attr)
    return newID

  def insert_data(self,parentID):
    # Veritaban ilemi yapar
    pass
  
  def update(self,dic):
    # Parametre zelliklerini deitirir
    dic = self.control_attr(dic)
    param_id = dic["paramid"]
    parentID = get_parent(self.tagid)
    rec = self.qref.getChilds(parentID,"param","*",["tagid","!=",self.tagid])
    paramid_list = []
    for r in rec:
      paramid_list.append(r["paramid"])
    while param_id in paramid_list:
      param_id = param_id + "_"
    dic["paramid"] = param_id
    self.attr = dic
    self.qref.updateNode(self.tagid,self.attr)
    
    
  def delete(self):
    # Parametre'yi siler
    self.delete_ref()
    
  def delete_ref(self):
    self.qref.delete(self.tagid)    
    
  def delete_data(self):
    pass
        
  def control_attr(self,dic):
    # Parametre zelliklerini kontrol eder
    dic = copy.deepcopy(dic)
    # Attr dzgn gelmis mi?
    if (not dic.has_key("paramid")) or \
       (not dic.has_key("fieldrelation")) or \
       (not dic.has_key("paramtype")):
      if not dic.has_key("paramid"):
        dic["paramid"] = string.split(str(time.time()),".")[0]
      if not dic.has_key("fieldrelation"):
        dic["fieldrelation"] = ""
      if not dic.has_key("paramtype"):
        dic["paramtype"] = "2"  
        
    if dic["paramtype"] == "":
      dic["paramtype"] = "2"
    if dic["paramid"] == "":
      dic["paramid"] = string.split(str(time.time()),".")[0]
      
    dic["tagname"] = self.tagname
    dic["deleted"] = "0"
    
    return control_attr(dic)
  