# -*- coding: utf-8 -*- 
import kzFormGenerator
from kzFormGenerator import addProductForm, manage_addProduct
from Products.CMFCore.DirectoryView import registerDirectory
from Products.PythonScripts.Utility import allow_module, allow_class

# Make the skins available as DirectoryViews
registerDirectory('skins', globals())
registerDirectory('skins/kzFormGenerator/kzwidgets', globals())

kzFormGenerator_globals= globals()

def initialize(context): 
  " kzFormGenerator product'�t"

  context.registerClass(kzFormGenerator.kzFormGenerator, 
                        constructors = (addProductForm,
                                        manage_addProduct),
                        icon = 'formgenerator.gif')


allow_module('kzFormGenerator')
allow_module('kzOntimeScript')
allow_module('kzFields')
allow_module('kzTables')

from kzFormGenerator import kzForm
allow_class(kzForm)

from kzOntimeScript import kzOntimeScript
allow_class(kzOntimeScript)

from kzFields import kzField,kzEssentials
allow_class(kzField)
allow_class(kzEssentials)

from kzTables import base_table
allow_class(base_table)
