# -*- coding: utf-8 -*- 
import string
from Products.Kuzgun.kzString      import kzString

from types import UnicodeType


def u_code(text):
  # Unicode yapar
  return unicode(text)
  try:
    if type(text) == UnicodeType:
      return unicode(text)
    else:
      return str(text)
  except:
    return "???"

class kzTab:
  " Tablonun zorunlu alanlarn dzenler"
  
  def __init__(self):
    self.nodeID   = ""
    self.width    = 750
    self.tabCount = 6
    self.nodes    = []
    self.chrtopx  = 10
    self.language = "turkce"
    
    
  def getTabs(self):
    return self.nodes
    

  def printTabs(self,xml):
    " Tableri yazdr"
    maxRowCount = self.tabCount
    if len(self.nodes) == 0:
      return ""
    
    
    else: 
      # Grupta bulunan tablo saysndan tab satr saysn hesapla
      
      nodeCount = len(self.nodes)
      
      if (nodeCount % self.tabCount) == 0:
        rowCount  = nodeCount / maxRowCount
      else:
        rowCount  = nodeCount / maxRowCount + 1
        
      if (nodeCount % rowCount ) == 0:
        colCount  = nodeCount / rowCount
      else:
        colCount  = nodeCount / rowCount + 1                
      

      # Aktif tablonun, tm tablolar iindeki srasn bul
      
      aktiveIndex = 0
      for id,title in self.nodes:
        if id == self.nodeID:
          break
        aktiveIndex = aktiveIndex + 1
      
      
      table = xml.append("table", {"class":"tabTables", 
                        "cellspacing":"0",
                        "cellpadding":"0"} )
      xml.setParent(table)

      # Tablo listesinden satr gruplar halinde tablolar alarak ekrana yaz.
      # Fakat aktif tablonun olduu satr grubunu yazma
      
      begin = 0
      activeList=[]
      while rowCount > 0:
        if (aktiveIndex < begin) or \
          (aktiveIndex >= begin + colCount):
          
          if begin + colCount < nodeCount:
            width = self.width / (colCount)
            tr = xml.append("tr")
            xml.setParent(tr)
            td = xml.append("td")
            xml.setParent(td)
            self.printTabRow(xml,width, range(begin, begin+colCount) )
            xml.setParent(table)
            begin = begin + colCount

          else:
            width = self.width / (nodeCount-begin)
            tr = xml.append("tr")
            xml.setParent(tr)
            td = xml.append("td")
            xml.setParent(td)
            self.printTabRow(xml,width, range(begin, nodeCount) )
            xml.setParent(table)
            begin = nodeCount

        else:
          i = begin
          while (i < begin + colCount ) and ( i < nodeCount ):
            activeList.append(i)
            i = i + 1
          begin = begin + colCount
          
        rowCount = rowCount - 1
      
      try:  
        width = self.width / len(activeList) 
      except:
        width = 1
      xml.setParent(table)
      tr = xml.append("tr")
      xml.setParent(tr)
      td = xml.append("td")
      xml.setParent(td)
      self.printTabRow(xml,width,activeList)


    
  def printTabRow(self,xml,width,list):
    "Tablo secmeye yarayan kulakklardan bir satr"
    "ekillendirir ve geri dndrr."
    
    tabCharacterCount = int ( ( self.width - \
                  ( self.tabCount * 20 ) ) / \
                  (self.tabCount * 7 ) )
    
    table = xml.append("table", {"class":"tabTable", 
                      "cellspacing":"0",
                      "cellpadding":"0", 
                      "style":"width:"+str(self.width)+";"} )
    xml.setParent(table)
    tr = xml.append("tr")
    xml.setParent(tr)
    #word = kzString.kzString("","turkce")
    
    for i in list:
      node = self.nodes[i]
      if self.nodeID==node[0]:
        xml.setParent(tr)
        td = xml.append("td", {"class":"tabSelectedImage",
                      "width":"10px"} )
        xml.setParent(td)
        xml.append("img",{"src":"tabLeft.gif"} )
  
        xml.setParent(tr)
        td = xml.append("td", {"class":"tabSelected", 
                      "width":str(width-20)} )
        xml.setParent(td)
        word = kzString.kzString(node[1],"turkce")
        word.abbreviation(tabCharacterCount)
        word.gramer()
        xml.append("button",{"class":"selectedTabButton", 
                      "type":"submit", 
                      "name":"table_"+node[0],
                      "id":node[0],
                      "style":"width:"+str(width-20)+"px; padding:0px;",
                      "onclick":"pass(form,this)"}
                ,text= word.out() )
        
        xml.setParent(tr)
        td = xml.append("td", {"class":"tabSelectedImage", 
                      "width":"10px"} )
        xml.setParent(td)
        xml.append("img",{"src":"tabRight.gif"} )
    
      else: 
        xml.setParent(tr)
        td = xml.append("td", {"class":"tabImage", 
                      "width":"10px"} )
        xml.setParent(td)
        xml.append("img",{"src":"tabLeft.gif"})
  
        xml.setParent(tr)
        td = xml.append("td", {"class":"tabNotSelected", 
                      "width":str(width-20)} )
        xml.setParent(td)
        word = kzString.kzString(node[1],"turkce")
        word.abbreviation(tabCharacterCount)
        word.gramer()
        xml.append("button",{"class":"tabButton", 
                      "type":"submit", 
                      "name":"table_"+node[0],
                      "id":node[0], 
                      "style":"width:"+str(width-20)+"px; padding:0px;",
                      "onclick":"pass(form,this)"}
                ,text=word.out() )
  
        xml.setParent(tr)
        td = xml.append("td", {"class":"tabImage", 
                      "width":"10px"} )
        xml.setParent(td)
        xml.append("img",{"src":"tabRight.gif"})

  