# -*- coding: utf-8 -*- 
#kzTemplates
from OFS import SimpleItem

from Products.Kuzgun.kzXMLSentence import kzXMLSentence
from Products.Kuzgun.kzString      import kzString
from Products.Kuzgun.kzSort        import kzSort

from OFS.FindSupport               import FindSupport

class kzTemplates:
  # Sistemde var olan Sablonlar listeler
  
  def __init__(self,parent):
    self.parent  = parent
    self.tableid = parent.getActiveTableID()
    self.list    = []
    self.xml     = None
    
  def printlist(self):
    self.getlist()
    self.xml = kzXMLSentence()
    self.xml.setParent(self.xml.append("div"))
    table = self.xml.append("table",{"style":"border-width:1px; border-style:solid;"})
    self.xml.setParent(table)
    self.xml.setParent(self.xml.append("tr"))
    self.xml.setParent(self.xml.append("th",text="LIST"))
    for l in self.list:
      self.xml.setParent(table)
      self.xml.setParent(self.xml.append("tr"))
      self.xml.setParent(self.xml.append("td"))
      self.xml.append("a",{"href":l[1]},text=l[0])

    return self.xml.printOut()  
    
  
  
  def getlist(self):
    container = self.parent.qref.getContainer(self.tableid)
    self.list = []
    list      = FindSupport.ZopeFind(FindSupport(container), container, [],
                                     ['kzTemplates'],search_sub=0)
    
    for l in list:
      tableid = getattr(l[1],'Table ID')
      self.list.append( (l[1].title,"%s/kzFormTemplates_view" % (l[1].absolute_url()) ) )
        