## Script (Python) "getKzDTreeMenuJavaScript"
##parameters=groupid='g0'
##bind container=container
##bind context=context
##bind namespace=_
##bind script=script
##bind subpath=traverse_subpath
##title=

jscript=[]

def scan(tagid,treeid,parentIndex):
  groups = qref.getChilds_auth(tagid,"group",restriction = ["activate","==","1"])
  kzSort.kzSort([groups,('order','max')])
  for group in groups:
    gtitle = group.get("title","No Title")
    gtagid = group.get("tagid")
    gdefaultconds = group.get("defaultconds","")
    gdefaultconsts = group.get("defaultconsts","")
    gdefaultgroup = group.get("defaultgroup","")
    if gdefaultgroup:
      targetgroup = gdefaultgroup
    else:
      targetgroup = gtagid
    menu_index = len(jscript) + 1
    # xx.add(id,pid,name,url,title,target,icon,iconopen,open)
    if group.get("isleaf","T") == "F":
      jscript.append( "%s.add(%s,%s,'%s')" % (treeid,menu_index,parentIndex,gtitle) )
      scan(gtagid,treeid,menu_index)
    else:
      url = "formGen?group=%s&defaultconds=%s&defaultconsts=%s" % (targetgroup,gdefaultconds,gdefaultconsts)
      jscript.append( '%s.add(%s,%s,"%s","%s","%s","kuzgun_form","img/page.gif")' % (treeid,menu_index,parentIndex,gtitle,url,gtitle) )


from Products.Kuzgun import kzSort
qref = container.getKuzgunReference()

jscript.append("%s = new dTree('%s')" % (groupid,groupid))
group=qref.getAttributes(groupid)
jscript.append( "%s.add(%s,%s,'%s')" % (groupid,1,-1,group.get("title","No Title")) )
scan(groupid,groupid,1)
jscript.append("document.write(%s)" % (groupid))

return ";".join(jscript)



  


