from Products.CMFCore.CMFCorePermissions import AddPortalContent
from Products.Archetypes.public import *

PROJECTNAME = 'kzReport'

ADD_FOLDER_PERMISSION = AddPortalContent

SKINS_DIR = 'skins'

i18n_domain = 'kuzgun'

GLOBALS = globals()

schema = BaseSchema  + Schema((
  
  
  StringField('tableid',
              widget=StringWidget(label_msgid="label_tableid",
                                  description_msgid="help_tableid",
                                  label='Table Id',
                                  i18n_domain=i18n_domain),
              ),
    
  LinesField('sysparams',
             widget=LinesWidget(label_msgid="label_sysparams",
                                description_msgid="help_sysparams",
                                label='System Parameters',
                                i18n_domain=i18n_domain),
             ),
  
  TextField('templatetext',
            widget=RichWidget(label_msgid="label_templatetext",
                              description_msgid="help_templatetext",
                              label='Template Text',
                              rows=40,cols=60,
                              i18n_domain=i18n_domain),
            ),
  
  LinesField('scriptparams',
             widget=LinesWidget(label_msgid="label_scriptparams",
                                description_msgid="help_scriptparams",
                                label='Script Parameters',
                                i18n_domain=i18n_domain),
             ),
  
  TextField('scripttext',
            widget=TextAreaWidget(label_msgid="label_scripttext",
                                  description_msgid="help_scripttext",
                                  label='Python Script Text',
                                  rows=40,cols=60,
                                  i18n_domain=i18n_domain),
            ),

  ))

