## Script (Python) "update_kzTask"
##parameters=
##bind container=container
##bind context=context
##bind namespace=_
##bind script=script
##bind subpath=traverse_subpath
##title=Görev güncellenir


from DateTime import DateTime

year  = context.REQUEST.get('deadtime_year','')
month = context.REQUEST.get('deadtime_month','')
day   = context.REQUEST.get('deadtime_day','')

id   = context.REQUEST.get('id','')

title       = context.REQUEST.get('title','')
destination = context.REQUEST.get('destination','')

deadtime = "%s/%s/%s" % (year,month,day)

try:
  d = DateTime(deadtime)
  context.REQUEST.set('deadtime',deadtime)

  if not title:
    err_msg = "?portal_status_message=Please enter a valid title&id=%s" % id
    url = 'kzTask_update' + err_msg

  elif not destination:
    err_msg = "?portal_status_message=Please enter a valid destination&id=%s" % id
    url = 'kzTask_update' + err_msg

  else:
    context.kzTaskManager.update(context.REQUEST)
    if context.REQUEST.has_key('detail'):
      url = 'kzTask_inbox'
    else:
      url = 'kzTask_outbox'  

except:
  err_msg = "?portal_status_message=Please enter a valid date&id=%s" % id
  url = 'kzTask_update' + err_msg

context.REQUEST.RESPONSE.redirect(url)


