import string
from OFS.Folder import manage_addFolder

class kzManageProducts:
  # Kullanici productlarini duzenler
      
  def __init__(self,container,userid,kzRefDataID,kzAuthSqlID):
    self.userid = userid
    try: self.container = container.Members.Objects
    except: raise "kzManageProducts:Members.Objects not found"
    self.kzAuthSqlID = kzAuthSqlID
    self.kzRefDataID = kzRefDataID
    
    
  def getSubObject(self,container,objectid):
    for object in container.objectValues():
        if object.id == objectid:
          return object
    return None      
    
  ###############################################################
  ###############################################################
  ## MODULE FOLDER ##############################################
  ###############################################################      
    
  def getMemberModuleFolder(self):
    memberModuleFolder = self.getSubObject(self.container,self.userid)
    if not memberModuleFolder:
      self.addMemberModuleFolder()
      memberModuleFolder = self.getSubObject(self.container,self.userid)
    return memberModuleFolder  

  def delMemberModuleFoldet(self): 
    try: self.container._delObject(self.userid)
    except: pass
    
  def addMemberModuleFolder(self):
    manage_addFolder(self.container,id=self.userid)
    container = getattr(self.container,self.userid)
    container.__ac_local_roles__      = {}
    container.__ac_local_roles__[self.userid] = ['Owner']    
    
  ###############################################################
  ###############################################################
  ## MODULE OBJECT ##############################################
  ###############################################################    
    
   
  def getMemberModuleObject(self,id):
    memberModuleFolder = self.getMemberModuleFolder()
    if memberModuleFolder:
      return self.getSubObject(memberModuleFolder,id)
    else:
      return None
    
  def getModuleObject(self,module):
    if module == "users":
      object = getattr(self.container,'kzUserManagement',None)

    elif module == "desicion":
      object = self.getMemberModuleObject("kzDBDesign")
      if not object:
        memberModuleFolder = self.getMemberModuleFolder()
        memberModuleFolder.manage_addProduct['kzDBDesign'].manage_addProduct(id='kzDBDesign', title='',
                                                                             qref=self.kzRefDataID,qdata=self.kzAuthSqlID)
        memberModuleFolder.kzDBDesign.__ac_local_roles__ = {}
        memberModuleFolder.kzDBDesign.__ac_local_roles__[self.userid] = ['Owner']
        object = self.getMemberModuleObject("kzDBDesign")
        
    elif module == "menu":
      object = getattr(self.container,'kzUserManagement',None)

    elif module == "form":
      object = self.getMemberModuleObject("kzFormGenerator")
      if not object:
        memberModuleFolder = self.getMemberModuleFolder()
        memberModuleFolder.manage_addProduct['kzFormGenerator'].manage_addProduct(id='kzFormGenerator', title='',
                                                                                  qref=self.kzRefDataID,qdata=self.kzAuthSqlID)
        memberModuleFolder.kzFormGenerator.__ac_local_roles__ = {}
        memberModuleFolder.kzFormGenerator.__ac_local_roles__[self.userid] = ['Owner']
        object = self.getMemberModuleObject("kzFormGenerator")
        
    elif module == "query":
      object = getattr(self.container,'kzUserManagement',None)  
      
    return object  
      
        

   
